package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        int count = 0;
        if (!isEmpty()) {
            for (int i = 0; i < entries.length; i++) {
                if (entries[i].size() > 0) count++;
            }
            return count;
        } else return 0;
    }

    @Override
    public boolean isEmpty() {
        int count = 0;
        for (int i = 0; i < entries.length; i++) {
            if (entries[i].size() != 0) count++;
        }
        return count == 0;
    }

    @Override
    public Cart get(User key) {
        Cart cart = null;
        for (Entry e : entries[bucketIndex(key)]) {
            cart = e.getValue();
        }
        return cart;
    }

    @Override
    public void put(User key, Cart value) {
        Entry e = new Entry(key, value);
        entries[bucketIndex(key)].add(e);
    }

    @Override
    public List<User> getKeys() {
        List<User> keys = new ArrayList<>();
        for (int i = 0; i < entries.length; i++) {
            for (Entry e : entries[i]) {
                keys.add(e.getKey());
            }
        }
        return keys;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> values = new ArrayList<>();
        for (int i = 0; i < entries.length; i++) {
            for (Entry e : entries[i]) {
                values.add(e.getValue());
            }
        }
        return values;
    }

    @Override
    public Cart remove(User key) {
        return null;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
